# generated by datamodel-codegen:
#   filename:  openapi.json
#   timestamp: 2022-11-15T15:49:04+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Any, Dict, List, Optional

from pydantic import Field

from kelvin.sdk.client.base_model import BaseModelRoot
from kelvin.sdk.client.data_model import DataModelBase


class ACPLocationItem(DataModelBase):
    """
    ACPLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = None
    lon: Optional[float] = None


class ACPMetadataBulkCreateItem(DataModelBase):
    """
    ACPMetadataBulkCreateItem object.

    Parameters
    ----------
    acp_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    acp_name: Optional[str] = None
    name: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None


class ACPMetadataBulkDeleteItem(DataModelBase):
    """
    ACPMetadataBulkDeleteItem object.

    Parameters
    ----------
    acp_name: Optional[str]
    name: Optional[str]

    """

    acp_name: Optional[str] = None
    name: Optional[str] = None


class ACPMetadataCreate(DataModelBase):
    """
    ACPMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class ACPMetadataUpdate(DataModelBase):
    """
    ACPMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class ACPSettingAutoUpdate(DataModelBase):
    """
    ACPSettingAutoUpdate object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ACPSettingMetrics(DataModelBase):
    """
    ACPSettingMetrics object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ACPSettingSync(DataModelBase):
    """
    ACPSettingSync object.

    Parameters
    ----------
    interval: Optional[int]

    """

    interval: Optional[int] = None


class ACPStatusUpdateValues(DataModelBase):
    """
    ACPStatusUpdateValues object.

    Parameters
    ----------
    message: Optional[str]
    state: Optional[str]
    warnings: Optional[List[str]]

    """

    message: Optional[str] = None
    state: Optional[str] = None
    warnings: Optional[List[str]] = None


class ACPUpdate(DataModelBase):
    """
    ACPUpdate object.

    Parameters
    ----------
    location: Optional[ACPLocationItem]
    manifests_scrape_interval: Optional[int]
    sync_scrape_interval: Optional[int]
    telemetry_scrape_interval: Optional[int]
    title: Optional[str]

    """

    location: Optional[ACPLocationItem] = None
    manifests_scrape_interval: Optional[int] = None
    sync_scrape_interval: Optional[int] = None
    telemetry_scrape_interval: Optional[int] = None
    title: Optional[str] = Field(None, max_length=64)


class AlarmClassCreate(DataModelBase):
    """
    AlarmClassCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmClassUpdate(DataModelBase):
    """
    AlarmClassUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(None, max_length=64)


class AlarmClustering(DataModelBase):
    """
    AlarmClustering object.

    Parameters
    ----------
    alarm_severities: Optional[List[int]]
    asset_include_children: Optional[bool]
    end_date: Optional[datetime]
    start_date: Optional[datetime]
    target_asset_names: Optional[List[str]]
    time_bucket: Optional[str]

    """

    alarm_severities: Optional[List[int]] = None
    asset_include_children: Optional[bool] = None
    end_date: Optional[datetime] = None
    start_date: Optional[datetime] = None
    target_asset_names: Optional[List[str]] = None
    time_bucket: Optional[str] = None


class AlarmConditionTargetNotificationsUserSetting(DataModelBase):
    """
    AlarmConditionTargetNotificationsUserSetting object.

    Parameters
    ----------
    enabled: Optional[bool]
    type: Optional[str]

    """

    enabled: Optional[bool] = None
    type: Optional[str] = None


class AlarmFilterCreate(DataModelBase):
    """
    AlarmFilterCreate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]
    title: Optional[str]
    username: Optional[str]
    version: Optional[str]

    """

    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = None
    username: Optional[str] = None
    version: Optional[str] = None


class AlarmFilterUpdate(DataModelBase):
    """
    AlarmFilterUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]
    title: Optional[str]
    version: Optional[str]

    """

    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = None
    version: Optional[str] = None


class AlarmSeverity(DataModelBase):
    """
    AlarmSeverity object.

    Parameters
    ----------
    name: Optional[str]
    severity: Optional[int]
    title: Optional[str]

    """

    name: Optional[str] = None
    severity: Optional[int] = None
    title: Optional[str] = None


class AlarmSeverityUpdate(DataModelBase):
    """
    AlarmSeverityUpdate object.

    Parameters
    ----------
    data: Optional[List[AlarmSeverity]]

    """

    data: Optional[List[AlarmSeverity]] = None


class AlarmTagCreate(DataModelBase):
    """
    AlarmTagCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmTagUpdate(DataModelBase):
    """
    AlarmTagUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class AlarmTypeCreate(DataModelBase):
    """
    AlarmTypeCreate object.

    Parameters
    ----------
    alarm_class_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    alarm_class_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmTypeUpdate(DataModelBase):
    """
    AlarmTypeUpdate object.

    Parameters
    ----------
    alarm_class_name: Optional[str]
    title: Optional[str]

    """

    alarm_class_name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmUpdate(DataModelBase):
    """
    AlarmUpdate object.

    Parameters
    ----------
    alarm_type_name: Optional[str]
    custom_identifier: Optional[str]
    description: Optional[str]
    payload: Optional[Dict[str, Any]]
    severity: Optional[int]
    solution: Optional[str]
    source_asset_names: Optional[List[str]]
    tags: Optional[List[str]]
    target_asset_name: Optional[str]
    title: Optional[str]

    """

    alarm_type_name: Optional[str] = None
    custom_identifier: Optional[str] = None
    description: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None
    severity: Optional[int] = None
    solution: Optional[str] = None
    source_asset_names: Optional[List[str]] = None
    tags: Optional[List[str]] = None
    target_asset_name: Optional[str] = None
    title: Optional[str] = None


class AlarmUpdateStatus(DataModelBase):
    """
    AlarmUpdateStatus object.

    Parameters
    ----------
    status: Optional[str]
    status_payload: Optional[Dict[str, Any]]

    """

    status: Optional[str] = None
    status_payload: Optional[Dict[str, Any]] = None


class AppCreate(DataModelBase):
    """
    AppCreate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class AppUpdate(DataModelBase):
    """
    AppUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class AssetClassCreate(DataModelBase):
    """
    AssetClassCreate object.

    Parameters
    ----------
    entity_type_name: str
    name: str
    title: str

    """

    entity_type_name: str = Field(
        ...,
        description="<a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Type</a> that is linked to this new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class\" target=\"_blank\">Kelvin Asset Class</a>.</p> There are 5 <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Type</a> options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> and function of each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Type</a> can be found at <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.",
        max_length=64,
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetClassUpdate(DataModelBase):
    """
    AssetClassUpdate object.

    Parameters
    ----------
    entity_type_name: Optional[str]
    title: str

    """

    entity_type_name: Optional[str] = Field(
        None,
        description='New entity type that is linked to this existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
        max_length=64,
    )
    title: str = Field(
        ...,
        description='New display name for this existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetDataStreamsList(DataModelBase):
    """
    AssetDataStreamsList object.

    Parameters
    ----------
    include_asset_children: Optional[bool]

    """

    include_asset_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair objects for the `asset_name` declared.",
    )


class AssetLocationItem(DataModelBase):
    """
    AssetLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = Field(
        None,
        description='Latitude coordinates of where the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> is geographically located.</p> This is saved in decimal degree format. e.g. `37.774929`.</p> The default is 0.',
    )
    lon: Optional[float] = Field(
        None,
        description='Longitude coordinates of where the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> is geographically located.</p> This is saved in decimal degree format. e.g. `\t-122.419416`.</p> The default is 0.',
    )


class AssetMetricItem(DataModelBase):
    """
    AssetMetricItem object.

    Parameters
    ----------
    name: Optional[str]

    """

    name: Optional[str] = Field(None, description="Unused. This is reserved as a future feature.")


class AssetOEEGet(DataModelBase):
    """
    AssetOEEGet object.

    Parameters
    ----------
    asset_names: List[str]
    timestamp: Optional[str]

    """

    asset_names: List[str] = Field(
        ...,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the OEE statistics.",
    )
    timestamp: Optional[str] = Field(
        None,
        description="Timestamp to search for specific <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> related <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-asset-details/#performance-details' target='_blank'>OEE</a> values for a given point in time (supports RFC3339 and Unix timestamps with nanosecond precision).</p> If no timestamp is given in the query or body parameters, then the current time will be selected.",
    )


class AssetPropertyCreate(DataModelBase):
    """
    AssetPropertyCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description='Unique identifier name for this property in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: Optional[str] = Field(
        None,
        description='Display name (title) for this property in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    value: Optional[str] = Field(None, description="Value for this property.")


class AssetStatistics(DataModelBase):
    """
    AssetStatistics object.

    Parameters
    ----------
    asset_type_names: Optional[List[str]]
    entity_type_names: Optional[List[str]]
    names: Optional[List[str]]
    search: Optional[List[str]]

    """

    asset_type_names: Optional[List[str]] = Field(
        None,
        description="Array of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Types</a> to be included in the filter.",
    )
    entity_type_names: Optional[List[str]] = Field(
        None,
        description="Array of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Types</a> to be included in the filter. There are five options available for the array; `group`, `asset`, `component`, `part` or `sensor`.",
    )
    names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> to return statistics on.</p> OEE information will only be included for <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="Search and filter the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> list. The `name`, `title`, `asset_type_name`, `asset_type_title`, `entity_type_name` and `entity_type_title` will be included in the search field criteria. This is given as an array, for example `[pump,fan]`.</p> The search is case insensitive and will find partial matches as well. For example if a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> name or display name is `centrifugal_pump`, then a match will be made if the search string is `pum` or `FUGaL`.",
    )


class AssetTemplateProperties(DataModelBase):
    """
    AssetTemplateProperties object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description='Default unique identifier name for this property in the new Kelvin Template.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    title: Optional[str] = Field(
        None,
        description='Default display name (title) for this property in the new Kelvin Template. This is a friendly name displayed in lists and in references.</p> You can use any character, numeric, space and special character in this parameter.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    value: Optional[str] = Field(
        None,
        description='Default value for this property. This can be a string, integer, float or boolean.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )


class AssetTypeCreate(DataModelBase):
    """
    AssetTypeCreate object.

    Parameters
    ----------
    asset_class_name: str
    name: str
    title: str

    """

    asset_class_name: str = Field(
        ...,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> A 400 error will occur if the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> does not exist and this API request will fail.',
        max_length=64,
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: str = Field(
        ...,
        description='Display name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetTypeMetadataCreate(DataModelBase):
    """
    AssetTypeMetadataCreate object.

    Parameters
    ----------
    name: str
    payload: Dict[str, Any]

    """

    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    payload: Dict[str, Any] = Field(
        ...,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class AssetTypeMetadataUpdate(DataModelBase):
    """
    AssetTypeMetadataUpdate object.

    Parameters
    ----------
    payload: Dict[str, Any]

    """

    payload: Dict[str, Any] = Field(
        ...,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class AssetTypeUpdate(DataModelBase):
    """
    AssetTypeUpdate object.

    Parameters
    ----------
    asset_class_name: Optional[str]
    title: Optional[str]

    """

    asset_class_name: Optional[str] = Field(
        None,
        description='Link to a different existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> Use the name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> in this parameter and not the Display Name (title). The <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> must be created and existing before you can change the link here.',
        max_length=64,
    )
    title: Optional[str] = Field(
        None,
        description='New display name(title) for this existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class BridgeDeploy(DataModelBase):
    """
    BridgeDeploy object.

    Parameters
    ----------
    acp_name: str
    name: str
    payload: Dict[str, Any]
    protocol: str
    title: str

    """

    acp_name: str = Field(
        ...,
        description="Unique identifier name of an existing <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    name: str = Field(
        ...,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Dict[str, Any] = Field(
        ...,
        description="Custom JSON object holding all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs and their communication specifications and addresses.</p> This JSON structure will depend on the type of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> bring deployed. The type is the Protocol parameter here.",
    )
    protocol: str = Field(
        ...,
        description="This is the type of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> communication protocol. There are four protocols available; `opc-ua`, `mqtt`, `modbus`, `roc`. Full details about these protocols are explained in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Documentation Overview</a>",
        max_length=64,
    )
    title: str = Field(
        ...,
        description="Display name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )


class CarbonEmissionsSetting(DataModelBase):
    """
    CarbonEmissionsSetting object.

    Parameters
    ----------
    co2_per_kwh: Optional[float]
    co2_per_metric_tone: Optional[float]
    cost_per_kwh: Optional[float]
    daily_runtime: Optional[float]
    forest_acres_factor: Optional[float]
    forest_acres_preserved_factor: Optional[float]
    power_consumption_factor: Optional[float]
    tree_seedlings_factor: Optional[float]
    workload_percentage: Optional[float]
    year_work_days: Optional[int]

    """

    co2_per_kwh: Optional[float] = None
    co2_per_metric_tone: Optional[float] = None
    cost_per_kwh: Optional[float] = None
    daily_runtime: Optional[float] = None
    forest_acres_factor: Optional[float] = None
    forest_acres_preserved_factor: Optional[float] = None
    power_consumption_factor: Optional[float] = None
    tree_seedlings_factor: Optional[float] = None
    workload_percentage: Optional[float] = None
    year_work_days: Optional[int] = None


class ClusterLocationItem(DataModelBase):
    """
    ClusterLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = None
    lon: Optional[float] = None


class ClusterUpdate(DataModelBase):
    """
    ClusterUpdate object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    kelvin_info: Optional[Dict[str, Any]]
    kubeconfig: Optional[str]
    network_info: Optional[Dict[str, Any]]
    ready: Optional[bool]
    system_info: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    info: Optional[Dict[str, Any]] = None
    kelvin_info: Optional[Dict[str, Any]] = None
    kubeconfig: Optional[str] = None
    network_info: Optional[Dict[str, Any]] = None
    ready: Optional[bool] = None
    system_info: Optional[Dict[str, Any]] = None
    title: Optional[str] = None


class ControlChangeClustering(DataModelBase):
    """
    ControlChangeClustering object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: Optional[List[str]]
    end_date: Optional[datetime]
    metric_names: Optional[List[str]]
    start_date: Optional[datetime]
    states: Optional[List[str]]
    time_bucket: Optional[str]

    """

    asset_include_children: Optional[bool] = None
    asset_names: Optional[List[str]] = None
    end_date: Optional[datetime] = None
    metric_names: Optional[List[str]] = None
    start_date: Optional[datetime] = None
    states: Optional[List[str]] = None
    time_bucket: Optional[str] = None


class ControlChangeCreate(DataModelBase):
    """
    ControlChangeCreate object.

    Parameters
    ----------
    asset_name: str
    expiration_date: Optional[datetime]
    metric_name: str
    payload: Optional[Dict[str, Any]]
    retry: Optional[int]
    timeout: Optional[int]

    """

    asset_name: str = Field(
        ...,
        description="Name of an existing <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    expiration_date: Optional[datetime] = Field(
        None,
        description="Date/time when the Control Change request will fail and return a `failed` status if it has not been `applied` yet.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.</p> The default value is calculated by the formulae <strong>Now + (`timeout` * ( `retry` + 1 ))</strong>.",
    )
    metric_name: str = Field(
        ...,
        description='Name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> in a deployed <a href=\'https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/\' target=\'_blank\'>Kelvin Bridge</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON structure with a `value` key and the new value to write to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair.</p> For example </p> <blockquote>\"payload\": {</br>&nbsp;&nbsp;&nbsp;&nbsp;\"value\": 888</br>}</blockquote>",
    )
    retry: Optional[int] = Field(
        None,
        description="How many times the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will try and send the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> request to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> before the change is tagged `failed` and no further attempts will be made.</p> The default value is 0.</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> sends a `processed` acknowledgment, then the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will stop any further retries and wait for an `applied` response.",
    )
    timeout: Optional[int] = Field(
        None,
        description="How long the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will wait in seconds for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> to send an `processed` acknowledgement before a retry will be attempted. If the total number of retries has reach its `retry` limit, then the change is tagged `failed` and no further attempts will be made.</p> The default is 300 seconds.",
    )


class AssetName(BaseModelRoot[str]):
    """
    AssetName object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class MetricName(BaseModelRoot[str]):
    """
    MetricName object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class ControlChangeLast(DataModelBase):
    """
    ControlChangeLast object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: List[AssetName]
    metric_names: Optional[List[MetricName]]
    states: Optional[List[str]]

    """

    asset_include_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>  objects for the `asset_names` declared.",
    )
    asset_names: List[AssetName] = Field(
        ...,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the last <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    metric_names: Optional[List[MetricName]] = Field(
        None,
        description='An array of one or more <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )


class AssetNameModel(BaseModelRoot[str]):
    """
    AssetNameModel object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class Id(BaseModelRoot[str]):
    """
    Id object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class MetricNameModel(BaseModelRoot[str]):
    """
    MetricNameModel object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class ControlChangeList(DataModelBase):
    """
    ControlChangeList object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: Optional[List[AssetNameModel]]
    ids: Optional[List[Id]]
    metric_names: Optional[List[MetricNameModel]]
    states: Optional[List[str]]

    """

    asset_include_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>  objects for the `asset_names` declared.",
    )
    asset_names: Optional[List[AssetNameModel]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    ids: Optional[List[Id]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> IDs, to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only UUID type strings.",
    )
    metric_names: Optional[List[MetricNameModel]] = Field(
        None,
        description='An array of one or more <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )


class ControlChangePayload(DataModelBase):
    """
    ControlChangePayload object.

    Parameters
    ----------
    expiration_date: Optional[datetime]
    payload: Optional[Dict[str, Any]]
    retries: Optional[int]
    timeout: Optional[int]

    """

    expiration_date: Optional[datetime] = Field(
        None,
        description="Date/time when the Control Change request will fail and return a `failed` status if it has not been `applied` yet.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.</p> The default value is calculated by the formulae <strong>Now + (`timeout` * ( `retry` + 1 ))</strong>.",
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON structure with a `value` key and the new value to write to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair.</p> For example </p> <blockquote>\"payload\": {</br>&nbsp;&nbsp;&nbsp;&nbsp;\"value\": 888</br>}</blockquote>",
    )
    retries: Optional[int] = Field(
        None,
        description="How many times the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will try and send the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> request to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> before the change is tagged `failed` and no further attempts will be made.</p> The default value is 0.</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> sends a `processed` acknowledgment, then the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will stop any further retries and wait for an `applied` response.",
    )
    timeout: Optional[int] = Field(
        None,
        description="How long the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will wait in seconds for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> to send an `processed` acknowledgement before a retry will be attempted. If the total number of retries has reach its `retry` limit, then the change is tagged `failed` and no further attempts will be made.</p> The default is 300 seconds.",
    )


class AssetNameModel1(BaseModelRoot[str]):
    """
    AssetNameModel1 object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class MetricNameModel1(BaseModelRoot[str]):
    """
    MetricNameModel1 object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class ControlChangeRange(DataModelBase):
    """
    ControlChangeRange object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: List[AssetNameModel1]
    end_date: datetime
    metric_names: Optional[List[MetricNameModel1]]
    start_date: datetime
    states: Optional[List[str]]

    """

    asset_include_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>  objects for the `asset_names` declared.",
    )
    asset_names: List[AssetNameModel1] = Field(
        ...,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> that have occurred.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    end_date: datetime = Field(
        ...,
        description="Most recent (end) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    metric_names: Optional[List[MetricNameModel1]] = Field(
        None,
        description='An array of one or more <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    start_date: datetime = Field(
        ...,
        description="Earliest (start) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )


class ControlChangeStatusPayload(DataModelBase):
    """
    ControlChangeStatusPayload object.

    Parameters
    ----------
    message: Optional[str]
    payload: Optional[Dict[str, Any]]
    state: Optional[str]

    """

    message: Optional[str] = Field(
        None,
        description="A message about the change in status. This will only appear if there is a message attached.",
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description="`pending` status will show a blank dictionary. `sent`, `applied` and `failed` will show the current value of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair.",
    )
    state: Optional[str] = Field(
        None,
        description="<a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> updated state.</p> There are four states available; `pending`, `sent`, `applied` and `failed`.",
    )


class ControlChangeUploadRequest(DataModelBase):
    """
    ControlChangeUploadRequest object.

    Parameters
    ----------
    id: str
    payload: Optional[ControlChangePayload]
    resource: Optional[str]
    source: Optional[str]
    timestamp: Optional[datetime]

    """

    id: str = Field(
        ...,
        description="Unique identifier id for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This ID is assigned to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> with the response to a `/control-changes/create` API request.</p> This must contain only lowercase alphanumeric characters and the `-` character only. For example `764168a8-0e1e-33aa-adc7-14dfbb78dfad`.",
    )
    payload: Optional[ControlChangePayload] = None
    resource: Optional[str] = Field(
        None,
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    source: Optional[str] = Field(
        None,
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    timestamp: Optional[datetime] = Field(
        None,
        description='Time in ISO 8601 UTC date/time format. Example; "2022-08-22T08:41:01.657916Z".',
    )


class CreatedBy(DataModelBase):
    """
    CreatedBy object.

    Parameters
    ----------
    name: Optional[str]
    type: Optional[str]

    """

    name: Optional[str] = None
    type: Optional[str] = None


class Type(Enum):
    user = "user"
    workload = "workload"


class DataLabelSource(DataModelBase):
    """
    DataLabelSource object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    type: Optional[Type]

    """

    info: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON object of key/value pairs to describe the type source.</p> For `workload` this will normally have the name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-apps/' target='_blank'>Kelvin App</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> that creates this information or for `user` this will usually be the `username` and `user_id`.",
    )
    type: Optional[Type] = Field(
        None,
        description="The type of source process.</p> There are two options `workload` and `user`.",
    )


class DeleteSelector(DataModelBase):
    """
    DeleteSelector object.

    Parameters
    ----------
    asset_name: str
    name: str

    """

    asset_name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )


class FailureDetectionProperty(DataModelBase):
    """
    FailureDetectionProperty object.

    Parameters
    ----------
    name: Optional[str]
    unit: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description='Unique identifier name for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> property.</p> This must match the existing available properties for each type of <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> model.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    unit: Optional[str] = Field(
        None,
        description='The units for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> property.',
    )
    value: Optional[str] = Field(
        None,
        description='The value for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> property.',
    )


class FailureDetectionTemplate(DataModelBase):
    """
    FailureDetectionTemplate object.

    Parameters
    ----------
    enabled: Optional[bool]
    failure_class_name: Optional[str]

    """

    enabled: Optional[bool] = Field(
        None,
        description='The default activation state of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p>  `true` (enabled) and `false` (disabled).</p> The default is `false` (disabled).</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    failure_class_name: Optional[str] = Field(
        None,
        description='The name (not the Display Name / Title) of the default <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection Class</a>.</p> This parameter is only used when <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> is enabled.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )


class FailureOverview(DataModelBase):
    """
    FailureOverview object.

    Parameters
    ----------
    alarm_severities: Optional[List[int]]
    asset_names: Optional[List[str]]
    asset_type_names: Optional[List[str]]
    map_names: Optional[List[str]]
    parent_asset_name: Optional[str]
    search: Optional[List[str]]

    """

    alarm_severities: Optional[List[int]] = Field(
        None,
        description="Array of <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-alarms#alarm-severity' target='_blank'>Kelvin Maps Alarm Severity</a> to be used as an `OR` in the filtered results.</p> This is an integer number between 1 and 5, with; 1 representing `critical`, 2 is `urgent`, 3 is `advisory`, 4 is `medium` and 5 is `low`.",
    )
    asset_names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> to filter failure overview results.</p> Failure overview information will only be included for <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )
    asset_type_names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> to filter the failure overview results.",
    )
    map_names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> to filter failure overview results.</p> Failure overview information will only be included for <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> which represent the process maps in <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview' target='_blank'>Kelvin Maps</a>. These have an entity type `production-line`.",
    )
    parent_asset_name: Optional[str] = None
    search: Optional[List[str]] = Field(
        None,
        description="Array of strings to be used as an `OR` in the filtered results.</p> Each string will be used to search the field `name`, `title`. The search is case insensitive.",
    )


class ICDField(DataModelBase):
    """
    ICDField object.

    Parameters
    ----------
    array: Optional[bool]
    description: Optional[str]
    name: Optional[str]
    type: Optional[str]

    """

    array: Optional[bool] = None
    description: Optional[str] = None
    name: Optional[str] = None
    type: Optional[str] = None


class ICDPayload(DataModelBase):
    """
    ICDPayload object.

    Parameters
    ----------
    class_name: Optional[str]
    description: Optional[str]
    fields: Optional[List[ICDField]]
    name: Optional[str]
    version: Optional[str]

    """

    class_name: Optional[str] = None
    description: Optional[str] = None
    fields: Optional[List[ICDField]] = None
    name: Optional[str] = None
    version: Optional[str] = None


class InstanceSettingUpdate(DataModelBase):
    """
    InstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class IntegrationAwsRegionCreate(DataModelBase):
    """
    IntegrationAwsRegionCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = None
    title: Optional[str] = None


class IntegrationAwsRegionUpdate(DataModelBase):
    """
    IntegrationAwsRegionUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class IntegrationConfiguration(DataModelBase):
    """
    IntegrationConfiguration object.

    Parameters
    ----------
    aws_access_key_id: Optional[str]
    aws_region: Optional[str]
    aws_secret_access_key: Optional[str]
    polling_rate: Optional[int]

    """

    aws_access_key_id: Optional[str] = None
    aws_region: Optional[str] = None
    aws_secret_access_key: Optional[str] = None
    polling_rate: Optional[int] = None


class IntegrationCreate(DataModelBase):
    """
    IntegrationCreate object.

    Parameters
    ----------
    configuration: Optional[IntegrationConfiguration]
    enable: Optional[bool]
    name: Optional[str]
    title: Optional[str]
    type: Optional[str]

    """

    configuration: Optional[IntegrationConfiguration] = None
    enable: Optional[bool] = None
    name: Optional[str] = None
    title: Optional[str] = None
    type: Optional[str] = None


class IntegrationUpdate(DataModelBase):
    """
    IntegrationUpdate object.

    Parameters
    ----------
    configuration: Optional[IntegrationConfiguration]
    enable: Optional[bool]
    title: Optional[str]

    """

    configuration: Optional[IntegrationConfiguration] = None
    enable: Optional[bool] = None
    title: Optional[str] = None


class KelvinCarbonEmissionsInstanceSettingUpdate(DataModelBase):
    """
    KelvinCarbonEmissionsInstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[CarbonEmissionsSetting]

    """

    payload: Optional[CarbonEmissionsSetting] = None


class KelvinContactInfoSetting(DataModelBase):
    """
    KelvinContactInfoSetting object.

    Parameters
    ----------
    email: Optional[str]
    phone_country_code: Optional[str]
    phone_number: Optional[str]

    """

    email: Optional[str] = None
    phone_country_code: Optional[str] = None
    phone_number: Optional[str] = None


class KelvinContactInfoUserSettingUpdate(DataModelBase):
    """
    KelvinContactInfoUserSettingUpdate object.

    Parameters
    ----------
    payload: Optional[KelvinContactInfoSetting]

    """

    payload: Optional[KelvinContactInfoSetting] = None


class LabelCreate(DataModelBase):
    """
    LabelCreate object.

    Parameters
    ----------
    name: str
    title: str

    """

    name: str = Field(
        ...,
        description="Unique identifier name for the Label.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> This is the name used when referenced from <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a>",
        max_length=64,
    )
    title: str = Field(
        ...,
        description="Display name for this new Label. This is a friendly name for the Label.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )


class LabelMetadataBulkCreateItem(DataModelBase):
    """
    LabelMetadataBulkCreateItem object.

    Parameters
    ----------
    label_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    label_name: Optional[str] = Field(
        None,
        description="This is the name from the Label variable which can be created with the Kelvin API `/datalabels/labels/create`.</p> If the Label name does not exist, it will be automatically created.",
        max_length=64,
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class LabelMetadataCreate(DataModelBase):
    """
    LabelMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class LabelMetadataDeleteBulkItem(DataModelBase):
    """
    LabelMetadataDeleteBulkItem object.

    Parameters
    ----------
    label_name: Optional[str]
    name: Optional[str]

    """

    label_name: Optional[str] = Field(
        None,
        description="This is the name from the Label variable which can be created with the Kelvin API `/datalabels/labels/create`.</p> If the Label name does not exist, it will be automatically created.",
        max_length=64,
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )


class LabelMetadataUpdate(DataModelBase):
    """
    LabelMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = Field(
        None,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class LabelUpdate(DataModelBase):
    """
    LabelUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(
        None,
        description="Display name for this new Label. This is a friendly name for the Label.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )


class LoopConfig(DataModelBase):
    """
    LoopConfig object.

    Parameters
    ----------
    every: Optional[int]

    """

    every: Optional[int] = None


class MapOEEGet(DataModelBase):
    """
    MapOEEGet object.

    Parameters
    ----------
    map_names: Optional[List[str]]
    timestamp: Optional[str]

    """

    map_names: Optional[List[str]] = None
    timestamp: Optional[str] = None


class MapRelationship(DataModelBase):
    """
    MapRelationship object.

    Parameters
    ----------
    source: Optional[str]
    target: Optional[str]
    type: Optional[str]
    visualization: Optional[Dict[str, Any]]

    """

    source: Optional[str] = None
    target: Optional[str] = None
    type: Optional[str] = None
    visualization: Optional[Dict[str, Any]] = None


class MapShiftGet(DataModelBase):
    """
    MapShiftGet object.

    Parameters
    ----------
    map_names: Optional[List[str]]
    timestamp: Optional[str]

    """

    map_names: Optional[List[str]] = None
    timestamp: Optional[str] = None


class Metric(DataModelBase):
    """
    Metric object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]

    """

    asset_name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class MetricCreate(DataModelBase):
    """
    MetricCreate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    data_type_version: Optional[str]
    display_unit: Optional[str]
    name: Optional[str]
    semantic_type_name: Optional[str]
    semantic_type_properties: Optional[Dict[str, Any]]
    title: Optional[str]
    write: Optional[bool]

    """

    data_type_name: Optional[str] = Field(
        None,
        description="Type of data being recorded to this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> there are 13 types of data type options; `raw.boolean`, `raw.dynacard`, `raw.float32`, `raw.float64`, `raw.int8`, `raw.int16`, `raw.int32`, `raw.int64`, `raw.uint8`, `raw.uint16`, `raw.uint32`, `raw.uint64` and `raw.text`.",
    )
    data_type_version: Optional[str] = Field(
        None, description="Version of the data type.</p> For example `2.0.0`."
    )
    display_unit: Optional[str] = Field(
        None,
        description="Units for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This can be anything to describe the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> units. For example `Amp`, `Hz`, `॰F`, etc.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    semantic_type_name: Optional[str] = Field(
        None,
        description="Type of sensor that is streaming data to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. Depending on the options chosen, there may be more properties available which will be saved to the `SemanticTypeProperties` parameters.</p> There are currently 28 Semantic Type Names available; `None`, `Accelerometer`, `Current`, `Dynacard`, `Event Flow Rate`, `Force`, `Frequency`, `Gas Flow Rate`, `Gas Volume`, `Humidity`, `Latitude`, `Length`, `Location`, `Longitude`, `Mass`, `Power`, `Pressure`, `Relative Humidity`, `State`, `Temperature`, `Time Date`, `Time Span`, `Torque`, `Velocity`, `Vibration`, `Voltage`, `Volume`, `Volume Flow Rate`.",
    )
    semantic_type_properties: Optional[Dict[str, Any]] = Field(
        None,
        description="Additional properties depending on the selected `SemanticTypeName` parameter chosen.</p> For example; if the semantic type chosen is `temperature`, then there will be an additional parameter in semantic type properties for `temperature unit` where fahrenheit or celsius can be chosen.",
    )
    title: Optional[str] = Field(
        None,
        description="Display name (title) for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    write: Optional[bool] = Field(
        None,
        description="Defines whether this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> is read only (`false`) or read/write (`true`).</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> feature is used on this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>, then this parameter must be `true`.",
    )


class MetricUpdate(DataModelBase):
    """
    MetricUpdate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    data_type_version: Optional[str]
    display_unit: Optional[str]
    semantic_type_name: Optional[str]
    semantic_type_properties: Optional[Dict[str, Any]]
    title: Optional[str]
    write: Optional[bool]

    """

    data_type_name: Optional[str] = Field(
        None,
        description="Type of data being recorded to this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> there are 13 types of data type options; `raw.boolean`, `raw.dynacard`, `raw.float32`, `raw.float64`, `raw.int8`, `raw.int16`, `raw.int32`, `raw.int64`, `raw.uint8`, `raw.uint16`, `raw.uint32`, `raw.uint64` and `raw.text`.",
    )
    data_type_version: Optional[str] = Field(
        None, description="Version of the data type.</p> For example `2.0.0`."
    )
    display_unit: Optional[str] = Field(
        None,
        description="Units for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This can be anything to describe the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> units. For example `Amp`, `Hz`, `॰F`, etc.",
        max_length=64,
    )
    semantic_type_name: Optional[str] = Field(
        None,
        description="Type of sensor that is streaming data to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. Depending on the options chosen, there may be more properties available which will be saved to the `SemanticTypeProperties` parameters.</p> There are currently 28 Semantic Type Names available; `None`, `Accelerometer`, `Current`, `Dynacard`, `Event Flow Rate`, `Force`, `Frequency`, `Gas Flow Rate`, `Gas Volume`, `Humidity`, `Latitude`, `Length`, `Location`, `Longitude`, `Mass`, `Power`, `Pressure`, `Relative Humidity`, `State`, `Temperature`, `Time Date`, `Time Span`, `Torque`, `Velocity`, `Vibration`, `Voltage`, `Volume`, `Volume Flow Rate`.",
    )
    semantic_type_properties: Optional[Dict[str, Any]] = Field(
        None,
        description="Additional properties depending on the selected `SemanticTypeName` parameter chosen.</p> For example; if the semantic type chosen is `temperature`, then there will be an additional parameter in semantic type properties for `temperature unit` where fahrenheit or celsius can be chosen.",
    )
    title: Optional[str] = Field(
        None,
        description="Display name (title) for this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    write: Optional[bool] = Field(
        None,
        description="Defines whether this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> is read only (`false`) or read/write (`true`).</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> feature is used on this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>, then this parameter must be `true`.",
    )


class OEECalculation(DataModelBase):
    """
    OEECalculation object.

    Parameters
    ----------
    good_units: Optional[int]
    ideal_cycle_time: Optional[int]
    planned_production_time: Optional[int]
    run_time: Optional[int]
    total_units: Optional[int]

    """

    good_units: Optional[int] = Field(
        None, description="Total number of goods produced pieces, NOT including the defective ones."
    )
    ideal_cycle_time: Optional[int] = Field(
        None,
        description="Fastest cycle time that your process can achieve in optimal circumstances with no stop time. Make sure all time units use the same baseline such as seconds, minutes, hours or days.",
    )
    planned_production_time: Optional[int] = Field(
        None,
        description="Amount of time the process is planned to be running. Make sure all time units use the same baseline such as seconds, minutes, hours or days.",
    )
    run_time: Optional[int] = Field(
        None,
        description="Total time that the process was running (not stopped) during the Planned Production Time. Make sure all time units use the same baseline such as seconds, minutes, hours or days.",
    )
    total_units: Optional[int] = Field(
        None, description="Total number of produced pieces, INCLUDING the defective ones"
    )


class OEEThresholds(DataModelBase):
    """
    OEEThresholds object.

    Parameters
    ----------
    critical_alarm: Optional[int]
    target: Optional[int]
    warning_alarm: Optional[int]

    """

    critical_alarm: Optional[int] = Field(
        None,
        description='Critical alarm threshold value (in percentage) for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> at the nominated timestamp.',
    )
    target: Optional[int] = Field(
        None,
        description='Target OEE value (in percentage) for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> at the nominated timestamp.',
    )
    warning_alarm: Optional[int] = Field(
        None,
        description='Warning alarm threshold value (in percentage) for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> at the nominated timestamp.',
    )


class ParameterUpdate(DataModelBase):
    """
    ParameterUpdate object.

    Parameters
    ----------
    payload: Dict[str, Any]

    """

    payload: Dict[str, Any]


class ProcessesList(DataModelBase):
    """
    ProcessesList object.

    Parameters
    ----------
    alarm_statuses: Optional[List[str]]
    asset_name: Optional[str]
    mode: Optional[str]

    """

    alarm_statuses: Optional[List[str]] = None
    asset_name: Optional[str] = None
    mode: Optional[str] = None


class ProductionInfo(DataModelBase):
    """
    ProductionInfo object.

    Parameters
    ----------
    expected_end_at: Optional[datetime]
    expected_start_at: Optional[datetime]
    sku: Optional[str]

    """

    expected_end_at: Optional[datetime] = None
    expected_start_at: Optional[datetime] = None
    sku: Optional[str] = None


class ReferenceMetric(DataModelBase):
    """
    ReferenceMetric object.

    Parameters
    ----------
    asset_name: Optional[str]
    metric_name: Optional[str]

    """

    asset_name: Optional[str] = None
    metric_name: Optional[str] = None


class ResponsibleFor(DataModelBase):
    """
    ResponsibleFor object.

    Parameters
    ----------
    name: Optional[str]
    type: Optional[str]

    """

    name: Optional[str] = None
    type: Optional[str] = None


class RuleAction(DataModelBase):
    """
    RuleAction object.

    Parameters
    ----------
    metric_name: Optional[str]
    target_asset_name: Optional[str]
    type: Optional[str]

    """

    metric_name: Optional[str] = Field(None, max_length=64)
    target_asset_name: Optional[str] = Field(None, max_length=64)
    type: Optional[str] = Field(None, max_length=64)


class RuleExecutionConfig(DataModelBase):
    """
    RuleExecutionConfig object.

    Parameters
    ----------
    loop_config: Optional[LoopConfig]
    mode: Optional[str]

    """

    loop_config: Optional[LoopConfig] = None
    mode: Optional[str] = None


class RuleInput(DataModelBase):
    """
    RuleInput object.

    Parameters
    ----------
    asset_name: Optional[str]
    metric_name: Optional[str]

    """

    asset_name: Optional[str] = Field(None, max_length=64)
    metric_name: Optional[str] = Field(None, max_length=64)


class RulePayload(DataModelBase):
    """
    RulePayload object.

    Parameters
    ----------
    actions: Optional[List[RuleAction]]
    execution_config: Optional[RuleExecutionConfig]
    inputs: Optional[List[RuleInput]]
    script: Optional[str]
    visualization: Optional[Dict[str, Any]]

    """

    actions: Optional[List[RuleAction]] = None
    execution_config: Optional[RuleExecutionConfig] = None
    inputs: Optional[List[RuleInput]] = None
    script: Optional[str] = None
    visualization: Optional[Dict[str, Any]] = None


class RuleUpdate(DataModelBase):
    """
    RuleUpdate object.

    Parameters
    ----------
    enabled: Optional[bool]
    map_name: Optional[str]
    payload: Optional[RulePayload]
    target: Optional[str]
    title: Optional[str]

    """

    enabled: Optional[bool] = None
    map_name: Optional[str] = Field(None, max_length=64)
    payload: Optional[RulePayload] = None
    target: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class SecretCreate(DataModelBase):
    """
    SecretCreate object.

    Parameters
    ----------
    name: str
    value: str

    """

    name: str = Field(..., max_length=32)
    value: str


class ShiftInfo(DataModelBase):
    """
    ShiftInfo object.

    Parameters
    ----------
    end_at: Optional[datetime]
    name: Optional[str]
    start_at: Optional[datetime]

    """

    end_at: Optional[datetime] = None
    name: Optional[str] = None
    start_at: Optional[datetime] = None


class StorageCreate(DataModelBase):
    """
    StorageCreate object.

    Parameters
    ----------
    asset_name: str
    data_type: str
    id: Optional[str]
    name: str
    payload: Dict[str, Any]
    source: Optional[str]
    target: Optional[str]
    timestamp: datetime
    trace_id: Optional[str]

    """

    asset_name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    data_type: str = Field(
        ...,
        description="Data type of the payload values. This should match the data type that is defined in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> used in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair defined in the `name` parameter.",
        max_length=64,
    )
    id: Optional[str] = None
    name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Dict[str, Any] = Field(
        ...,
        description="The actual payload of information saved for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> The standard payload will look like this</p>  <blockquote>{</br>&nbsp;&nbsp;\"payload\": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\"value\": 88</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>",
    )
    source: Optional[str] = Field(
        None,
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-apps/' target='_blank'>Kelvin App</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> that has collected the data and transmitted it to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=256,
    )
    target: Optional[str] = Field(
        None,
        description="This is not used for any <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> functions and can be defined by the user for custom information.",
        max_length=256,
    )
    timestamp: datetime = Field(
        ...,
        description='Time when the payload data was created at the source in ISO 8601 UTC date/time format. Example; "2022-07-08T08:41:01.657916Z".',
        example="2022-01-13T12:00:00.000000Z",
    )
    trace_id: Optional[str] = Field(
        None, description="This is for internal purposes and is the same as the `id`."
    )


class StorageDelete(DataModelBase):
    """
    StorageDelete object.

    Parameters
    ----------
    end_time: datetime
    selectors: List[DeleteSelector]
    start_time: datetime

    """

    end_time: datetime = Field(
        ...,
        description="End time for the recorded time to delete data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )
    selectors: List[DeleteSelector] = Field(
        ...,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs that you want to delete a range of historian data.",
    )
    start_time: datetime = Field(
        ...,
        description="Start time for the recorded time to delete data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )


class Order(Enum):
    ASC = "ASC"
    DESC = "DESC"


class StorageSelector(DataModelBase):
    """
    StorageSelector object.

    Parameters
    ----------
    asset_name: str
    fields: Optional[List[str]]
    name: str

    """

    asset_name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    fields: Optional[List[str]] = Field(
        None,
        description="Array of wanted keys that are recorded in the payload. Normally this will be `value`.</p> If there are other unique keys/value pairs in the payload, then you can create a list of all keys to retrieve the values. e.g. 'value,key2,key3'. If the key does not exist in the stored payload, that key will return with a value `null`.",
    )
    name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )


class StorageUpdate(DataModelBase):
    """
    StorageUpdate object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    asset_name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    title: Optional[str] = Field(
        None,
        description="New display name (title) for this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class SymbolCreate(DataModelBase):
    """
    SymbolCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[str]
    symbol_type: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = None
    payload: Optional[str] = None
    symbol_type: Optional[str] = None
    title: Optional[str] = None


class SymbolUpdate(DataModelBase):
    """
    SymbolUpdate object.

    Parameters
    ----------
    payload: Optional[str]
    symbol_type: Optional[str]
    title: Optional[str]

    """

    payload: Optional[str] = None
    symbol_type: Optional[str] = None
    title: Optional[str] = None


class TeamMember(DataModelBase):
    """
    TeamMember object.

    Parameters
    ----------
    email: Optional[str]
    name: Optional[str]
    phone_country_code: Optional[str]
    phone_number: Optional[str]
    responsible_for: Optional[ResponsibleFor]
    role: Optional[str]

    """

    email: Optional[str] = None
    name: Optional[str] = None
    phone_country_code: Optional[str] = None
    phone_number: Optional[str] = None
    responsible_for: Optional[ResponsibleFor] = None
    role: Optional[str] = None


class UserSettingUpdate(DataModelBase):
    """
    UserSettingUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class View2D(DataModelBase):
    """
    View2D object.

    Parameters
    ----------
    image_model: Optional[str]
    x: Optional[float]
    y: Optional[float]

    """

    image_model: Optional[str] = Field(
        None,
        description='A http(s) URL link to an SVG image used to visually display your <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.',
    )
    x: Optional[float] = Field(
        None,
        description="This is the x coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )
    y: Optional[float] = Field(
        None,
        description="This is the y coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )


class View3D(DataModelBase):
    """
    View3D object.

    Parameters
    ----------
    image_model: Optional[str]
    x: Optional[float]
    y: Optional[float]
    z: Optional[float]

    """

    image_model: Optional[str] = Field(
        None,
        description='A http(s) URL link to a GLB model used to visually display your <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.',
    )
    x: Optional[float] = Field(
        None,
        description="This is the x coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )
    y: Optional[float] = Field(
        None,
        description="This is the y coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )
    z: Optional[float] = Field(
        None,
        description="This is the z coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )


class Visualization(DataModelBase):
    """
    Visualization object.

    Parameters
    ----------
    view_2d: Optional[View2D]
    view_3d: Optional[View3D]

    """

    view_2d: Optional[View2D] = None
    view_3d: Optional[View3D] = None


class WireguardPeerCreate(DataModelBase):
    """
    WireguardPeerCreate object.

    Parameters
    ----------
    allowed_ips: Optional[List[str]]
    endpoint: Optional[str]
    name: str
    public_key: Optional[str]
    title: str
    type: str

    """

    allowed_ips: Optional[List[str]] = None
    endpoint: Optional[str] = None
    name: str
    public_key: Optional[str] = None
    title: str
    type: str


class WireguardPeerUpdate(DataModelBase):
    """
    WireguardPeerUpdate object.

    Parameters
    ----------
    allowed_ips: Optional[List[str]]
    endpoint: Optional[str]
    public_key: Optional[str]
    title: str
    type: str

    """

    allowed_ips: Optional[List[str]] = None
    endpoint: Optional[str] = None
    public_key: Optional[str] = None
    title: str
    type: str


class WireguardTunnelCreate(DataModelBase):
    """
    WireguardTunnelCreate object.

    Parameters
    ----------
    keep_alive: Optional[int]
    wireguard_peer: str

    """

    keep_alive: Optional[int] = None
    wireguard_peer: str


class WorkloadDeploy(DataModelBase):
    """
    WorkloadDeploy object.

    Parameters
    ----------
    acp_name: str
    app_name: str
    app_version: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    acp_name: str
    app_name: str
    app_version: Optional[str] = None
    name: Optional[str] = Field(None, max_length=32)
    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = Field(None, max_length=64)


class WorkloadStatusUpdateValues(DataModelBase):
    """
    WorkloadStatusUpdateValues object.

    Parameters
    ----------
    message: Optional[str]
    name: Optional[str]
    state: Optional[str]
    warnings: Optional[List[str]]

    """

    message: Optional[str] = None
    name: Optional[str] = None
    state: Optional[str] = None
    warnings: Optional[List[str]] = None


class ACPMetadataBulkCreate(BaseModelRoot[ACPMetadataBulkCreateItem]):
    """
    ACPMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[ACPMetadataBulkCreateItem]

    """

    __root__: List[ACPMetadataBulkCreateItem]


class ACPMetadataBulkDelete(BaseModelRoot[ACPMetadataBulkDeleteItem]):
    """
    ACPMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[ACPMetadataBulkDeleteItem]

    """

    __root__: List[ACPMetadataBulkDeleteItem]


class ACPSetting(DataModelBase):
    """
    ACPSetting object.

    Parameters
    ----------
    auto_update: Optional[ACPSettingAutoUpdate]
    metrics: Optional[ACPSettingMetrics]
    sync: Optional[ACPSettingSync]

    """

    auto_update: Optional[ACPSettingAutoUpdate] = None
    metrics: Optional[ACPSettingMetrics] = None
    sync: Optional[ACPSettingSync] = None


class ACPStatusUpdate(DataModelBase):
    """
    ACPStatusUpdate object.

    Parameters
    ----------
    configs: Optional[List[str]]
    node: Optional[ACPStatusUpdateValues]
    pending_workloads: Optional[List[WorkloadStatusUpdateValues]]
    workloads: Optional[List[WorkloadStatusUpdateValues]]

    """

    configs: Optional[List[str]] = None
    node: Optional[ACPStatusUpdateValues] = None
    pending_workloads: Optional[List[WorkloadStatusUpdateValues]] = None
    workloads: Optional[List[WorkloadStatusUpdateValues]] = None


class AlarmConditionNotificationsUserSetting(DataModelBase):
    """
    AlarmConditionNotificationsUserSetting object.

    Parameters
    ----------
    alarm_severity: Optional[List[int]]
    alarm_type_name: Optional[List[str]]
    asset_name: Optional[List[str]]
    name: Optional[str]
    targets: Optional[List[AlarmConditionTargetNotificationsUserSetting]]

    """

    alarm_severity: Optional[List[int]] = None
    alarm_type_name: Optional[List[str]] = None
    asset_name: Optional[List[str]] = None
    name: Optional[str] = None
    targets: Optional[List[AlarmConditionTargetNotificationsUserSetting]] = None


class AlarmCreate(DataModelBase):
    """
    AlarmCreate object.

    Parameters
    ----------
    alarm_type_name: str
    created_by: CreatedBy
    custom_identifier: Optional[str]
    description: Optional[str]
    payload: Optional[Dict[str, Any]]
    severity: Optional[int]
    solution: Optional[str]
    source_asset_names: List[str]
    tags: Optional[List[str]]
    target_asset_name: str
    title: str

    """

    alarm_type_name: str = Field(
        ...,
        description="The Alarm Type that is associated with this alarm. <i>Note: Before making a Kelvin Alarm the Kelvin Alarm Type and a Kelvin Alarm Class must exist in the Kelvin Platform. These can be created with API commands.</i>",
    )
    created_by: CreatedBy
    custom_identifier: Optional[str] = Field(
        None, description="An option to tag the alarm with a custom identifying string"
    )
    description: Optional[str] = Field(
        None, description="A summary description of what the alarm is about."
    )
    payload: Optional[Dict[str, Any]] = None
    severity: Optional[int] = Field(
        None,
        description="How serious the alarm is in a rating from 1 (most severe) to 5 (least severe).",
    )
    solution: Optional[str] = Field(
        None,
        description="Any tips to help users solve the alarm. <i>It is recommended to be as detailed as possible here.</i>",
    )
    source_asset_names: List[str] = Field(
        ...,
        description="A Name of a Kelvin Asset, Kelvin Component, Kelvin Part or Kelvin Sensor that actually generated the alarm. e.g. A Kelvin Sensor going over maximum is related to the health of a Kelvin Component.",
    )
    tags: Optional[List[str]] = None
    target_asset_name: str = Field(
        ...,
        description="A name of a Kelvin Asset, Kelvin Component, Kelvin Part or Kelvin Sensor that the alarm will be associated with. <i>Note: do not confuse this with the Display Name.</i>",
    )
    title: str = Field(..., description="The title of the alarm that will be displayed.")


class AlarmList(DataModelBase):
    """
    AlarmList object.

    Parameters
    ----------
    acknowledged_at_end: Optional[datetime]
    acknowledged_at_start: Optional[datetime]
    acknowledged_by: Optional[List[str]]
    alarm_class_names: Optional[List[str]]
    alarm_severities: Optional[List[int]]
    alarm_statuses: Optional[List[str]]
    alarm_type_names: Optional[List[str]]
    asset_class_names: Optional[List[str]]
    asset_include_children: Optional[bool]
    asset_type_names: Optional[List[str]]
    created_at_end: Optional[datetime]
    created_at_start: Optional[datetime]
    created_by: Optional[List[CreatedBy]]
    custom_identifiers: Optional[List[str]]
    resolved_at_end: Optional[datetime]
    resolved_at_start: Optional[datetime]
    resolved_by: Optional[List[str]]
    search: Optional[List[str]]
    tags: Optional[List[str]]
    target_asset_names: Optional[List[str]]

    """

    acknowledged_at_end: Optional[datetime] = None
    acknowledged_at_start: Optional[datetime] = None
    acknowledged_by: Optional[List[str]] = None
    alarm_class_names: Optional[List[str]] = None
    alarm_severities: Optional[List[int]] = None
    alarm_statuses: Optional[List[str]] = None
    alarm_type_names: Optional[List[str]] = None
    asset_class_names: Optional[List[str]] = None
    asset_include_children: Optional[bool] = None
    asset_type_names: Optional[List[str]] = None
    created_at_end: Optional[datetime] = None
    created_at_start: Optional[datetime] = None
    created_by: Optional[List[CreatedBy]] = None
    custom_identifiers: Optional[List[str]] = None
    resolved_at_end: Optional[datetime] = None
    resolved_at_start: Optional[datetime] = None
    resolved_by: Optional[List[str]] = None
    search: Optional[List[str]] = None
    tags: Optional[List[str]] = None
    target_asset_names: Optional[List[str]] = None


class AlarmNotificationsUserSetting(DataModelBase):
    """
    AlarmNotificationsUserSetting object.

    Parameters
    ----------
    conditions: Optional[List[AlarmConditionNotificationsUserSetting]]
    enabled: Optional[bool]

    """

    conditions: Optional[List[AlarmConditionNotificationsUserSetting]] = None
    enabled: Optional[bool] = None


class AnonymousTemplate(DataModelBase):
    """
    AnonymousTemplate object.

    Parameters
    ----------
    entity_type_name: Optional[str]
    failure_detection: Optional[FailureDetectionTemplate]
    properties: Optional[List[AssetTemplateProperties]]

    """

    entity_type_name: Optional[str] = Field(
        None,
        description='Entity type that is linked to this new Kelvin Template.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    failure_detection: Optional[FailureDetectionTemplate] = None
    properties: Optional[List[AssetTemplateProperties]] = None


class AssetOEE(DataModelBase):
    """
    AssetOEE object.

    Parameters
    ----------
    asset_name: Optional[str]
    oee_calculation: Optional[OEECalculation]
    oee_thresholds: Optional[OEEThresholds]

    """

    asset_name: Optional[str] = Field(
        None,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    oee_calculation: Optional[OEECalculation] = None
    oee_thresholds: Optional[OEEThresholds] = None


class AssetTemplateHierarchy(DataModelBase):
    """
    AssetTemplateHierarchy object.

    Parameters
    ----------
    from_template_name: Optional[str]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    metrics: Optional[List[AssetMetricItem]]
    template: Optional[AnonymousTemplate]
    title: Optional[str]
    visualization: Optional[Visualization]

    """

    from_template_name: Optional[str] = Field(
        None,
        description="Name of the Kelvin Template to copy its full <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> to this location.</p> If this parameter is used, no other parameter in this structure is required.",
    )
    hierarchy: Optional[List[AssetTemplateHierarchy]] = None
    metrics: Optional[List[AssetMetricItem]] = None
    template: Optional[AnonymousTemplate] = None
    title: Optional[str] = Field(
        None,
        description="Default display name (title) for this property in the new Kelvin Template. This is a friendly name displayed in lists and in references.</p> You can use any character, numeric, space and special character in this parameter.</p> This is shown as an example Display Name parameter field.</p> If you use `from_template_name parameter` this parameter is not required.",
    )
    visualization: Optional[Visualization] = None


class AssetTemplateUpdate(DataModelBase):
    """
    AssetTemplateUpdate object.

    Parameters
    ----------
    asset_type_name: Optional[str]
    description: Optional[str]
    entity_type_name: Optional[str]
    failure_detection: Optional[FailureDetectionTemplate]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    hints: Optional[Dict[str, Any]]
    image_url: Optional[str]
    metrics: Optional[List[AssetMetricItem]]
    properties: Optional[List[AssetTemplateProperties]]
    title: Optional[str]
    visualization: Optional[Visualization]

    """

    asset_type_name: Optional[str] = Field(
        None,
        description='The name (not the Display Name / Title) of the default <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> that will be selected.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    description: Optional[str] = Field(
        None, description="A full description of the Kelvin Template.", max_length=512
    )
    entity_type_name: Optional[str] = Field(
        None,
        description='Entity type that is linked to this new Kelvin Template.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
        max_length=64,
    )
    failure_detection: Optional[FailureDetectionTemplate] = None
    hierarchy: Optional[List[AssetTemplateHierarchy]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the Kelvin Template <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    hints: Optional[Dict[str, Any]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    image_url: Optional[str] = Field(
        None,
        description="A http(s) URL link to an image to visually display your template picture next to the description.</p> The file can be in any web-compatible format including jpg, png, gif, animated gif and apng. Even though any size is allowed as it will be automatically resized, it is advised to keep it below 400 x 400 px.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.",
    )
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    properties: Optional[List[AssetTemplateProperties]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    title: Optional[str] = Field(
        None,
        description="New display name (title) for the Kelvin Template. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class ClusterCreate(DataModelBase):
    """
    ClusterCreate object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    kelvin_info: Optional[Dict[str, Any]]
    kubeconfig: Optional[str]
    location: Optional[ClusterLocationItem]
    name: Optional[str]
    network_info: Optional[Dict[str, Any]]
    system_info: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    info: Optional[Dict[str, Any]] = None
    kelvin_info: Optional[Dict[str, Any]] = None
    kubeconfig: Optional[str] = None
    location: Optional[ClusterLocationItem] = None
    name: Optional[str] = None
    network_info: Optional[Dict[str, Any]] = None
    system_info: Optional[Dict[str, Any]] = None
    title: Optional[str] = None


class ControlChangeStatus(DataModelBase):
    """
    ControlChangeStatus object.

    Parameters
    ----------
    id: Optional[str]
    payload: Optional[ControlChangeStatusPayload]
    resource: Optional[str]
    timestamp: Optional[datetime]
    trace_id: str

    """

    id: Optional[str] = Field(
        None,
        description="Unique identifier id for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This ID is assigned to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> with the response to a `/control-changes/create` API request.</p> This must contain only lowercase alphanumeric characters and the `-` character only. For example `764168a8-0e1e-33aa-adc7-14dfbb78dfad`.",
    )
    payload: Optional[ControlChangeStatusPayload] = None
    resource: Optional[str] = Field(
        None,
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    timestamp: Optional[datetime] = Field(
        None,
        description='Time in ISO 8601 UTC date/time format. Example; "2022-08-22T08:41:01.657916Z".',
    )
    trace_id: str = Field(
        ..., description="This is for internal purposes and is the same as the `id`."
    )


class ControlChangeUpload(DataModelBase):
    """
    ControlChangeUpload object.

    Parameters
    ----------
    requests: Optional[List[ControlChangeUploadRequest]]
    statuses: Optional[List[ControlChangeStatus]]

    """

    requests: Optional[List[ControlChangeUploadRequest]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> requests on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.",
    )
    statuses: Optional[List[ControlChangeStatus]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> statuses on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.",
    )


class DataLabelCluster(DataModelBase):
    """
    DataLabelCluster object.

    Parameters
    ----------
    end_date: Optional[datetime]
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    start_date: Optional[datetime]
    time_bucket: Optional[str]

    """

    end_date: Optional[datetime] = Field(
        None,
        description="Timestamp for the end of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).</p> If the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> is a snapshot in time, the start_time and end_time can be the same.",
    )
    label_names: Optional[List[str]] = Field(
        None,
        description="Filter the returned results based on an Array of Label names.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> Each Label name will be filtered using the `OR` operator.",
    )
    metrics: Optional[List[Metric]] = Field(
        None,
        description="Filter the returned results based on an array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs.</p> Note : If you use this filter parameter, you can not just filter on a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. It must be the pair together.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair names will be filtered using the `OR` operator.",
    )
    start_date: Optional[datetime] = Field(
        None,
        description="Timestamp for the start of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).",
    )
    time_bucket: Optional[str] = Field(
        None,
        description="Time window to group and aggregate the occurrence of Labels within the defined time buckets.</p> Bucket time options available can be found at https://golang.org/pkg/time/#ParseDuration. For example '1h', '1m' or '2h45m'.",
    )


class DataLabelCreate(DataModelBase):
    """
    DataLabelCreate object.

    Parameters
    ----------
    confidence: Optional[int]
    description: Optional[str]
    end_date: datetime
    info: Optional[Dict[str, Any]]
    label_name: str
    metrics: List[Metric]
    source: DataLabelSource
    start_date: datetime
    validation: Optional[bool]

    """

    confidence: Optional[int] = Field(
        None,
        description="Option  for Machine Learning systems to save the confidence results of any model's output",
    )
    description: Optional[str] = Field(
        None,
        description="Any type of description that adequately explains this <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> entry. In a practical sense this description could be used in a dashboard for the operators to understand this particular <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a>.",
        max_length=256,
    )
    end_date: datetime = Field(
        ...,
        description="Timestamp for the end of a time range for which the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).</p> If the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> is a snapshot in time, the start_time and end_time can be the same.",
    )
    info: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON object with any key/value pairs that provide information about this Data Label.</p> It is recommended that any <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair instantaneous values that are referenced are also saved here rather than trying to link this timestamp to <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair recorded value timestamp.",
    )
    label_name: str = Field(
        ...,
        description="This is the name from the Label variable.</p> It can be created with the Kelvin API `/datalabels/labels/create`. If the Label name does not exist when creating a <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a>, it will be automatically created.",
        max_length=64,
    )
    metrics: List[Metric] = Field(
        ...,
        description="An array of JSON objects containing the Kelvin Asset name and Kelvin Metric name pairs that are related to the Data Label.",
    )
    source: DataLabelSource
    start_date: datetime = Field(
        ...,
        description="Timestamp for the start of a time range for which the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).",
    )
    validation: Optional[bool] = Field(
        None,
        description="Option for Machine Learning systems to save the validation results of any model's output",
    )


class DataLabelFilter(DataModelBase):
    """
    DataLabelFilter object.

    Parameters
    ----------
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    search: Optional[List[str]]

    """

    label_names: Optional[List[str]] = Field(
        None,
        description="An optional array of one or more Label Names to filter. All Label names will be filtered using **OR** operator.",
    )
    metrics: Optional[List[Metric]] = Field(
        None,
        description="An optional array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> Names to filter. All Label names will be filtered using **OR** operator.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="An optional array of one or more `description` or `label_names` to filter.<p> For example `[pump,fan]`. The search is case insensitive and will find partial matches as well. For example if a `description` or `label_name` is `centrifugal_pump`, then a match will be made if the search string is `pum` or `FUGaL`.",
    )


class DataLabelRange(DataModelBase):
    """
    DataLabelRange object.

    Parameters
    ----------
    end_date: datetime
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    start_date: datetime

    """

    end_date: datetime = Field(
        ...,
        description="Timestamp for the end of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).</p> If the Data Label is a snapshot in time, the start_time and end_time can be the same.",
    )
    label_names: Optional[List[str]] = Field(
        None,
        description="Filter the returned results based on an Array of Label names.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> Each Label name will be filtered using the `OR` operator.",
    )
    metrics: Optional[List[Metric]] = Field(
        None,
        description="Filter the returned results based on an array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs.</p> Note : If you use this filter parameter, you can not just filter on a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. It must be the pair together.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair names will be filtered using the `OR` operator.",
    )
    start_date: datetime = Field(
        ...,
        description="Timestamp for the start of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).",
    )


class DataTypeCreate(DataModelBase):
    """
    DataTypeCreate object.

    Parameters
    ----------
    icd: Optional[ICDPayload]
    schema_: Optional[Dict[str, Any]]
    source: Optional[str]

    """

    icd: Optional[ICDPayload] = None
    schema_: Optional[Dict[str, Any]] = Field(None, alias="schema")
    source: Optional[str] = None


class EntityReference(DataModelBase):
    """
    EntityReference object.

    Parameters
    ----------
    metric: Optional[ReferenceMetric]
    name: Optional[str]
    title: Optional[str]
    type: Optional[str]
    visualization: Optional[Dict[str, Any]]

    """

    metric: Optional[ReferenceMetric] = None
    name: Optional[str] = None
    title: Optional[str] = None
    type: Optional[str] = None
    visualization: Optional[Dict[str, Any]] = None


class FailureDetection(DataModelBase):
    """
    FailureDetection object.

    Parameters
    ----------
    enabled: Optional[bool]
    failure_class_name: Optional[str]
    properties: Optional[List[FailureDetectionProperty]]

    """

    enabled: Optional[bool] = Field(
        None,
        description='The activation state of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p>  `true` (enabled) and `false` (disabled).</p> The default is `false` (disabled).',
    )
    failure_class_name: Optional[str] = Field(
        None,
        description='The unique name (not the Display Name / Title) of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection Class</a>. You can find a full list of available Kelvin Failure Detection AI classes with the API request `/failure-detection/classes/list`.</p> This parameter is only used when <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> is enabled.',
    )
    properties: Optional[List[FailureDetectionProperty]] = Field(
        None,
        description='List of properties required by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> model. These options will vary and depends on the `failure_class_name` you have selected.</p> For example if you have a <a href=\'https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor\' target=\'_blank\'>Kelvin Sensor</a> and select the  `Vibration Piezo` failure class, then you will need to include information about the sampling rate, sample duration, axial/horizontal/vertical orientations. Any default values not set here must be filled in by the user when adding this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )


class HierarchyUpdateItem(DataModelBase):
    """
    HierarchyUpdateItem object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: str
    delete: Optional[bool]
    entity_type_name: str
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[HierarchyUpdateItem]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#kelvin-templates" target="_blank">Kelvin Template</a> used to create this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> If this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> was created from scratch, then this parameter will be `null`.',
    )
    asset_type_name: str = Field(
        ...,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    delete: Optional[bool] = Field(
        None,
        description="Delete this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> and its complete <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> If this parameter is marked `true`, then only the `name` is required as a parameter. Default is `false`.",
    )
    entity_type_name: str = Field(
        ...,
        description='Unique identifier name of the entity type linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.',
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[HierarchyUpdateItem]] = Field(
        None,
        description="A list of all <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Assets</a> which will include any <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> that are in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> below this <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Assets</a>.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None,
        description='List of all <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    name: str = Field(
        ...,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description='List of any custom properties for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    title: str = Field(
        ...,
        description='Display name (title) of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class KelvinACPInstanceSettingUpdate(DataModelBase):
    """
    KelvinACPInstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[ACPSetting]

    """

    payload: Optional[ACPSetting] = None


class LabelMetadataBulkCreate(BaseModelRoot[LabelMetadataBulkCreateItem]):
    """
    LabelMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[LabelMetadataBulkCreateItem]

    """

    __root__: List[LabelMetadataBulkCreateItem]


class LabelMetadataBulkDelete(BaseModelRoot[LabelMetadataDeleteBulkItem]):
    """
    LabelMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[LabelMetadataDeleteBulkItem]

    """

    __root__: List[LabelMetadataDeleteBulkItem]


class MapEntity(DataModelBase):
    """
    MapEntity object.

    Parameters
    ----------
    name: Optional[str]
    references: Optional[List[EntityReference]]
    title: Optional[str]
    visualization: Optional[Dict[str, Any]]

    """

    name: Optional[str] = None
    references: Optional[List[EntityReference]] = None
    title: Optional[str] = None
    visualization: Optional[Dict[str, Any]] = None


class MapOEECreate(DataModelBase):
    """
    MapOEECreate object.

    Parameters
    ----------
    assets_oee: Optional[List[AssetOEE]]

    """

    assets_oee: Optional[List[AssetOEE]] = None


class MapShiftCreate(DataModelBase):
    """
    MapShiftCreate object.

    Parameters
    ----------
    production_info: Optional[ProductionInfo]
    shift_info: Optional[ShiftInfo]
    team_info: Optional[List[TeamMember]]

    """

    production_info: Optional[ProductionInfo] = None
    shift_info: Optional[ShiftInfo] = None
    team_info: Optional[List[TeamMember]] = None


class MapUpdate(DataModelBase):
    """
    MapUpdate object.

    Parameters
    ----------
    asset_name: Optional[str]
    entities: Optional[List[MapEntity]]
    mode: Optional[str]
    relationships: Optional[List[MapRelationship]]
    title: Optional[str]

    """

    asset_name: Optional[str] = None
    entities: Optional[List[MapEntity]] = None
    mode: Optional[str] = None
    relationships: Optional[List[MapRelationship]] = None
    title: Optional[str] = None


class NotificationsUserSetting(DataModelBase):
    """
    NotificationsUserSetting object.

    Parameters
    ----------
    alarms: Optional[Dict[str, AlarmNotificationsUserSetting]]

    """

    alarms: Optional[Dict[str, AlarmNotificationsUserSetting]] = None


class NotificationsUserSettingUpdate(DataModelBase):
    """
    NotificationsUserSettingUpdate object.

    Parameters
    ----------
    payload: Optional[NotificationsUserSetting]

    """

    payload: Optional[NotificationsUserSetting] = None


class RuleCreate(DataModelBase):
    """
    RuleCreate object.

    Parameters
    ----------
    enabled: Optional[bool]
    map_name: Optional[str]
    name: Optional[str]
    payload: Optional[RulePayload]
    target: Optional[str]
    title: Optional[str]

    """

    enabled: Optional[bool] = None
    map_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=52)
    payload: Optional[RulePayload] = None
    target: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class StorageBulkCreate(DataModelBase):
    """
    StorageBulkCreate object.

    Parameters
    ----------
    data: List[StorageCreate]

    """

    data: List[StorageCreate] = Field(
        ...,
        description="An array of data values for a defined time for any number of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> // <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs to be saved on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a>.</p> Multiple data values for the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> // <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair can be saved but if there are conflicting timestamps then the last value only will be saved and the other values lost.",
    )


class StorageLast(DataModelBase):
    """
    StorageLast object.

    Parameters
    ----------
    selectors: List[StorageSelector]

    """

    selectors: List[StorageSelector] = Field(
        ...,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs that you want to retrieve historian data of the last known recorded payload.",
    )


class StorageRangeAdvanced(DataModelBase):
    """
    StorageRangeAdvanced object.

    Parameters
    ----------
    agg: Optional[str]
    end_time: datetime
    fill: Optional[str]
    group_by_selector: Optional[bool]
    order: Optional[Order]
    selectors: List[StorageSelector]
    start_time: datetime
    time_bucket: Optional[str]
    time_shift: Optional[str]

    """

    agg: Optional[str] = Field(
        None,
        description="Perform mathematical calculations on a group of data.</p> For numerical data there are twelve mathematical options available; `none` , `count`,`distinct`, `integral`, `mean`, `median`, `mode`, `spread`, `stddev`, `sum`, `max`, `min`.</p> For text based data there are three types of mathematical options available; `count`, `distinct`, `mode`. The default is `none`.</p> When using this parameter, you must also use the parameters `time_bucket` which defines how to group the data and `fields` which defines which payload data to use.",
    )
    end_time: datetime = Field(
        ...,
        description="End time for the recorded time to collect the payload data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )
    fill: Optional[str] = Field(
        None,
        description="Fills any group of data, which is defined by the `time_bucket` parameter, with a calculated value when there is no data in the database.</p> There are five options available; `none`, `null`, `linear`, `previous`, fixed integer value.</p> `none` will ignore the group. `null`, `previous` and fixed integer value will be added as the value for the empty group. `linear` will perform a linear regression to calculated the groups' value.</p> The default is `none`.",
    )
    group_by_selector: Optional[bool] = Field(
        None,
        description="Defines whether to group all filtered data into one result or separates the results for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair defined in the `selector` parameter.",
    )
    order: Optional[Order] = Field(
        None,
        description="Order of the results for the timestamp parameter.</p> There are two options available (capital letters is required); `ASC` for ascending and `DESC` for descending. The default is `ASC`.",
    )
    selectors: List[StorageSelector] = Field(
        ...,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs that you want to retrieve the data payloads.",
    )
    start_time: datetime = Field(
        ...,
        description="Start time for the recorded time to collect the payload data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )
    time_bucket: Optional[str] = Field(
        None,
        description="Group the data by time frame for the `agg` parameter calculations.</p> The time can be adjusted with these time units `ns`, `ms`, `s`, `m`, `h`. e.g. `8765h` equates to is 8,765 hours which is approximately one year.",
    )
    time_shift: Optional[str] = Field(
        None,
        description="Shift the time buckets from the epoch. Every time bucket starts from epoch so, if you want to calculate the time bucket starting on a different date and time, you'll need to set this. Example: `5m`, `1h`, `1w`.",
    )


class AssetCreate(DataModelBase):
    """
    AssetCreate object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: str
    entity_type_name: str
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    asset_type_name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> referenced by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> parameter.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> As this is creating additional <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>, the parameters here are the same as the Create Kelvin Asset.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class AssetCreateWithParent(DataModelBase):
    """
    AssetCreateWithParent object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: str
    entity_type_name: str
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    parent_name: Optional[str]
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    asset_type_name: str = Field(
        ...,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> A 400 error will occur if the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> does not exist and this API request will fail.',
        max_length=64,
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> referenced by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> parameter.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    parent_name: Optional[str] = Field(
        None,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> to assign as the parent to this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> The <a href=\'https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy\' target=\'_blank\'>hierarchy</a> of <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a> must be followed. For example a <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part" target="_blank">Kelvin Asset Part\'s</a> parent must have an entity type `component`. This parameter can be check in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> that is linked to the existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class AssetTemplateCreate(DataModelBase):
    """
    AssetTemplateCreate object.

    Parameters
    ----------
    asset_type_name: str
    description: Optional[str]
    entity_type_name: str
    failure_detection: Optional[FailureDetectionTemplate]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    hints: Optional[Dict[str, Any]]
    image_url: Optional[str]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    properties: Optional[List[AssetTemplateProperties]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_type_name: str = Field(
        ...,
        description='The name (not the Display Name / Title) of the default <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> that will be selected.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    description: Optional[str] = Field(
        None, description="A full description of the Kelvin Template.", max_length=512
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to this new Kelvin Template.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
        max_length=64,
    )
    failure_detection: Optional[FailureDetectionTemplate] = None
    hierarchy: Optional[List[AssetTemplateHierarchy]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the Kelvin Template <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    hints: Optional[Dict[str, Any]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    image_url: Optional[str] = Field(
        None,
        description="A http(s) URL link to an image to visually display your template picture next to the description.</p> The file can be in any web-compatible format including jpg, png, gif, animated gif and apng. Even though any size is allowed as it will be automatically resized, it is advised to keep it below 400 x 400 px.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.",
    )
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    name: str = Field(
        ...,
        description="Unique identifier name for this new Kelvin Template.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    properties: Optional[List[AssetTemplateProperties]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description="Display name (title) for this new Kelvin Template. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class AssetUpdate(DataModelBase):
    """
    AssetUpdate object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: Optional[str]
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    asset_type_name: Optional[str] = Field(
        None,
        description='New link to a unique identifier name for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='New optional display name (title) for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class HierarchyUpdate(DataModelBase):
    """
    HierarchyUpdate object.

    Parameters
    ----------
    data: Optional[List[HierarchyUpdateItem]]

    """

    data: Optional[List[HierarchyUpdateItem]] = Field(
        None,
        description="A dictionary with a data property of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> with their <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> structure to update.",
    )


class MapCreate(DataModelBase):
    """
    MapCreate object.

    Parameters
    ----------
    asset_name: Optional[str]
    entities: Optional[List[MapEntity]]
    mode: Optional[str]
    name: Optional[str]
    relationships: Optional[List[MapRelationship]]
    title: Optional[str]

    """

    asset_name: Optional[str] = None
    entities: Optional[List[MapEntity]] = None
    mode: Optional[str] = None
    name: Optional[str] = None
    relationships: Optional[List[MapRelationship]] = None
    title: Optional[str] = None


AssetTemplateHierarchy.update_forward_refs()
HierarchyUpdateItem.update_forward_refs()
AssetCreate.update_forward_refs()
